﻿Imports System.Threading.Tasks
Imports System

Public NotInheritable Class AssertEx
    Public Shared Async Function ThrowsAsync(Of TException As Exception)(ByVal action As Func(Of Task), Optional ByVal allowDerivedTypes As Boolean = True) As Task(Of TException)
        Try
            Await action()
        Catch ex As Exception
            If allowDerivedTypes AndAlso Not (TypeOf ex Is TException) Then
                Throw New Exception("Delegate threw exception of type " & ex.GetType.Name & ", but " & GetType(TException).Name & " or a derived type was expected.", ex)
            End If
            If (Not allowDerivedTypes) AndAlso ex.GetType IsNot GetType(TException) Then
                Throw New Exception("Delegate threw exception of type " & ex.GetType.Name & ", but " & GetType(TException).Name & " was expected.", ex)
            End If
            Return CType(ex, TException)
        End Try
        Throw New Exception("Delegate did not throw expected exception " & GetType(TException).Name & ".")
    End Function

    Public Shared Function ThrowsAsync(ByVal action As Func(Of Task)) As Task(Of Exception)
        Return ThrowsAsync(Of Exception)(action, True)
    End Function
End Class