﻿Imports System.Threading
Imports System.Threading.Tasks
Imports Microsoft.VisualStudio.TestPlatform.UnitTestFramework
Imports AsyncAssert = Microsoft.VisualStudio.TestPlatform.UnitTestFramework.AppContainer.Assert
Imports System

<TestClass>
Public Class WinStoreMSUnitTests
    ' Warning: bad code!
    <TestMethod>
    Public Sub IncorrectlyPassingTest()
        SystemUnderTest.FailAsync()
    End Sub

    <TestMethod>
    Public Async Function CorrectlyFailingTest() As Task
        Await SystemUnderTest.FailAsync
    End Function

    ' MSTest will refuse to execute this test (UTA007).
    <TestMethod>
    Public Async Sub SchrodingerTest()
        Await SystemUnderTest.FailAsync
    End Sub

    ' MSTest will refuse to execute this test (UTA007).
    <TestMethod>
    Public Async Sub SynchronizationContextNotDefinedForAsyncVoid()
        Assert.IsNull(SynchronizationContext.Current)
        Await Task.FromResult(0)
    End Sub

    <TestMethod>
    Public Async Function SynchronizationContextNotDefinedForAsyncTask() As Task
        Assert.IsNull(SynchronizationContext.Current)
        Await Task.FromResult(0)
    End Function

    <TestMethod>
    Public Sub SynchronizationContextNotDefinedForSynchronousTest()
        Assert.IsNull(SynchronizationContext.Current)
    End Sub

    ' New-style; only works on Windows Store.
    <TestMethod>
    Public Sub SynchronousFailureTest_AssertThrowsException()
        Dim ex As Exception = Assert.ThrowsException(Of Exception)(Sub() SystemUnderTest.Fail())
    End Sub

    Public Async Function FailureTest_AssertThrowsException() As Task
        Dim x As Exception = Await AsyncAssert.ThrowsException(Of Exception)(Function() SystemUnderTest.FailAsync)
        Assert.IsNotNull(x)
    End Function

    <TestMethod>
    Public Async Function FailureTest_AssertEx() As Task
        Dim x As Exception = Await AssertEx.ThrowsAsync(Function() SystemUnderTest.FailAsync)
        Assert.IsNotNull(x)
    End Function
End Class